(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/cdk/overlay'), require('@angular/forms'), require('@angular/common'), require('@angular/router'), require('@xdf/gallery'), require('@angular/material'), require('@xdf/commons'), require('@ngx-translate/core'), require('@xdf/layouts'), require('rxjs/operators'), require('@angular/material/dialog'), require('@angular/common/http'), require('rxjs'), require('ngx-scrollbar')) :
    typeof define === 'function' && define.amd ? define('@xdf/settings', ['exports', '@angular/core', '@angular/cdk/overlay', '@angular/forms', '@angular/common', '@angular/router', '@xdf/gallery', '@angular/material', '@xdf/commons', '@ngx-translate/core', '@xdf/layouts', 'rxjs/operators', '@angular/material/dialog', '@angular/common/http', 'rxjs', 'ngx-scrollbar'], factory) :
    (global = global || self, factory((global.xdf = global.xdf || {}, global.xdf.settings = {}), global.ng.core, global.ng.cdk.overlay, global.ng.forms, global.ng.common, global.ng.router, global['xdf-gallery'], global.ng.material, global.commons, global['ngx-translate'].core, global.layouts, global.rxjs.operators, global.ng.material.dialog, global.ng.common.http, global.rxjs, global.ngxScrollbar));
}(this, (function (exports, core, overlay, forms, common, router, gallery, material, commons, core$1, layouts, operators, dialog, http, rxjs, ngxScrollbar) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var SettingOptions = {
        INFO: 'information',
        PASSWORD: 'password',
        USERPOLICY: 'userpolicy',
        MAIL: 'mail',
    };
    var SystemSettingsComponent = /** @class */ (function () {
        function SystemSettingsComponent(route, router) {
            this.route = route;
            this.router = router;
            this.selected = 'information';
            this.mode = 'view';
            this.basePath = "/settings/system-settings";
        }
        /**
         * Método utilizado para saber si un formulario ha sido modificado
         */
        /**
         * Método utilizado para saber si un formulario ha sido modificado
         * @return {?}
         */
        SystemSettingsComponent.prototype.isDirty = /**
         * Método utilizado para saber si un formulario ha sido modificado
         * @return {?}
         */
        function () {
            return this.viewDirty.isDirty();
        };
        /**
         * @return {?}
         */
        SystemSettingsComponent.prototype.getRef = /**
         * @return {?}
         */
        function () {
            return this.viewDirty.getRef();
        };
        /**
         * @return {?}
         */
        SystemSettingsComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.templateDefinition = this.route.snapshot.data.template;
            /** @type {?} */
            var option = this.route.snapshot.data['option'];
            this.mode = this.route.snapshot.paramMap.get('mode');
            if (!this.mode)
                this.mode = 'view';
            if (option) {
                if (!gallery.Utilities.existValueInEnum(SettingOptions, option)) {
                    this.router.navigate(['/notfound']);
                    return;
                }
                this.selected = option;
            }
        };
        /**
         * @param {?} view
         * @return {?}
         */
        SystemSettingsComponent.prototype.changeView = /**
         * @param {?} view
         * @return {?}
         */
        function (view) {
            this.router.navigate([this.basePath + '/' + view]);
        };
        SystemSettingsComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-system-settings',
                        template: "<div class=\"wrapper wrapper-content\">\n    <div class=\"row\">\n        <div class=\"col-12 d-block d-lg-none d-xl-none\">\n            <div class=\"float-e-margins\">\n                <div class=\"ibox-content mailbox-content mini pull-right\">\n                    <mat-form-field>\n                        <mat-select [value]=\"selected\" (selectionChange)=\"changeView($event.value)\">\n                            <mat-option value=\"information\">{{ 'settings.general.information.short' | translate }}</mat-option>\n                            <mat-option value=\"password\">{{ 'settings.security.password.short' | translate }}</mat-option>\n                            <mat-option value=\"userpolicy\">{{ 'settings.security.user.policy.short' | translate }}</mat-option>\n                            <!-- <mat-option value=\"mail\">{{ 'settings.notification.mail.short' | translate }}</mat-option> -->\n                        </mat-select>\n                    </mat-form-field>\n                </div>\n            </div>\n        </div>\n    </div>\n    <div class=\"row\">\n        <div class=\"col-4 col-xl-3 d-none d-lg-block d-xl-block\">\n            <div class=\"float-e-margins\">\n                <div class=\"ibox-content mailbox-content\">\n                    <div class=\"file-manager\">\n                        <h5>{{ 'settings.general.header' | translate }}</h5>\n                        <ul class=\"folder-list m-b-md\">\n                            <li [ngClass]=\"{'active': selected === 'information'}\"><a (click)=\"changeView('information')\"> <i class=\"fa fa-info-circle\"></i>\n                                    {{ 'settings.general.information.short' | translate }}</a></li>\n                        </ul>\n                        <h5>{{ 'settings.security.header' | translate }}</h5>\n                        <ul class=\"folder-list m-b-md\">\n                            <li [ngClass]=\"{'active': selected === 'password'}\"><a (click)=\"changeView('password')\"> <i\n                                        class=\"fa  fa-key\"></i> {{ 'settings.security.password.short' | translate }}</a></li>\n                            <li [ngClass]=\"{'active': selected === 'userpolicy'}\"><a (click)=\"changeView('userpolicy')\"> <i\n                                        class=\"fa fa-user-secret\"></i> {{ 'settings.security.user.policy.short' | translate }}</a></li>\n                        </ul>\n                        <!-- <div class=\"space-15\"></div>\n                        <h5>{{ 'settings.notification.header' | translate }}</h5>\n                        <ul class=\"folder-list m-b-md\">\n                            <li [ngClass]=\"{'active': selected === 'mail'}\"><a (click)=\"changeView('mail')\"> <i\n                                        class=\"fa fa-envelope-o\"></i> {{ 'settings.notification.mail.short' | translate }}</a></li>\n                        </ul> -->\n                        <div class=\"clearfix\"></div>\n                    </div>\n                </div>\n            </div>\n        </div>\n \n        <div class=\"col-12 col-lg-8 col-xl-9 animated fadeInRight\" data-ui-view>\n            <xdf-form-view #content_form *ngIf=\"selected === 'information'\" [mode]=\"mode\" [showBack]=\"false\" [resetForm]=\"false\"></xdf-form-view>\n            <xdf-form-view #content_form *ngIf=\"selected === 'password'\" [mode]=\"mode\" [showBack]=\"false\" [resetForm]=\"false\"></xdf-form-view>\n            <xdf-form-view #content_form *ngIf=\"selected === 'userpolicy'\" [mode]=\"mode\" [showBack]=\"false\" [resetForm]=\"false\"></xdf-form-view>\n            <!-- <xdf-setting-mail #content_form *ngIf=\"selected === 'mail'\"></xdf-setting-mail> -->\n            \n            \n        </div>\n    </div>\n</div>",
                        styles: [".mini{padding:0}.ibox-content h4{margin:0}.folder-list{padding:0}.folder-list li{padding:0 0 0 10px;white-space:nowrap;border-bottom:0}.folder-list li.active{background-color:#fff}.file-manager h5{margin:0}::ng-deep .user-policy xdf-checkbox{font-size:10px!important}"]
                    }] }
        ];
        /** @nocollapse */
        SystemSettingsComponent.ctorParameters = function () { return [
            { type: router.ActivatedRoute },
            { type: router.Router }
        ]; };
        SystemSettingsComponent.propDecorators = {
            viewDirty: [{ type: core.ViewChild, args: ['content_form', { static: false },] }]
        };
        return SystemSettingsComponent;
    }());
    if (false) {
        /** @type {?} */
        SystemSettingsComponent.prototype.viewDirty;
        /** @type {?} */
        SystemSettingsComponent.prototype.selected;
        /** @type {?} */
        SystemSettingsComponent.prototype.mode;
        /** @type {?} */
        SystemSettingsComponent.prototype.templateDefinition;
        /** @type {?} */
        SystemSettingsComponent.prototype.basePath;
        /**
         * @type {?}
         * @protected
         */
        SystemSettingsComponent.prototype.route;
        /**
         * @type {?}
         * @protected
         */
        SystemSettingsComponent.prototype.router;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function DialogData() { }
    if (false) {
        /** @type {?} */
        DialogData.prototype.data;
    }
    var ViewCredencialsDialogComponent = /** @class */ (function () {
        function ViewCredencialsDialogComponent(dialogRef, dataDialog) {
            this.dialogRef = dialogRef;
            this.dataDialog = dataDialog;
            this.data = this.dataDialog.data;
            this.form = new forms.FormGroup({
                clientId: new forms.FormControl({ value: this.data['clientId'], disabled: true }),
                clientSecret: new forms.FormControl({ value: this.data['clientSecret'], disabled: true }),
                accessTokenValidity: new forms.FormControl({ value: this.data['accessTokenValidity'], disabled: true }),
                refreshTokenValidity: new forms.FormControl({ value: this.data['refreshTokenValidity'], disabled: true })
            });
        }
        /**
         * @return {?}
         */
        ViewCredencialsDialogComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        /**
         * @return {?}
         */
        ViewCredencialsDialogComponent.prototype.closeDialog = /**
         * @return {?}
         */
        function () {
            this.dialogRef.close();
        };
        /**
         * @return {?}
         */
        ViewCredencialsDialogComponent.prototype.onKeyUp = /**
         * @return {?}
         */
        function () {
            this.dialogRef.close();
        };
        ViewCredencialsDialogComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-view-credencials-dialog',
                        template: "<div class=\"close\">\n    <i class=\"fa fa-close\" (click)=\"closeDialog()\"></i>\n</div>\n<h1 mat-dialog-title class=\"dialog-title\">\n    {{ 'application_credentials_title' | translate}}\n</h1>\n<div mat-dialog-content class=\"dialog-content\">\n    <div class=\"group-content\" [formGroup]=\"form\">\n        <div class=\"row justify-content-md-center\">\n            <div class=\"form-group col-12\">\n                <xdf-input name=\"clientId\" label=\"application_form_client_id_placeholder\" \n                    type=\"text\" [required]=\"true\"\n                    placeholder=\"application_form_client_id_placeholder\" \n                    disabled=\"true\" [formGroup]=\"form\">\n                </xdf-input>\n            </div>\n            <div class=\"form-group col-12\">\n                <xdf-input name=\"clientSecret\" label=\"application_form_client_secret_placeholder\" \n                    type=\"text\" [required]=\"true\"\n                    placeholder=\"application_form_client_secret_placeholder\" \n                    disabled=\"true\" [formGroup]=\"form\">\n                </xdf-input>\n            </div>\n            <div class=\"form-group col-12\">\n                <xdf-input name=\"accessTokenValidity\" label=\"application_form_access_token_validity_placeholder\" \n                    type=\"text\" [required]=\"true\"\n                    placeholder=\"application_form_access_token_validity_placeholder\" \n                    disabled=\"true\" [formGroup]=\"form\">\n                </xdf-input>\n            </div>\n            <div class=\"form-group col-12\">\n                <xdf-input name=\"refreshTokenValidity\" label=\"application_form_refresh_token_validity_placeholder\" \n                    type=\"text\" [required]=\"true\"\n                    placeholder=\"application_form_refresh_token_validity_placeholder\" \n                    disabled=\"true\" [formGroup]=\"form\">\n                </xdf-input>\n            </div>\n        </div>\n    </div>\n</div>\n<div mat-dialog-actions class=\"border-top dialog-footer\">\n    <button type=\"button\" mat-button class=\"pull-right\" (click)=\"closeDialog()\">{{'btn.close' | translate}} </button>\n</div>",
                        encapsulation: core.ViewEncapsulation.None,
                        styles: [".dialog-footer button{margin-top:10px}.dialog-content{color:#676a6c}.close{cursor:pointer;margin-top:-10px;font-size:15px}"]
                    }] }
        ];
        /** @nocollapse */
        ViewCredencialsDialogComponent.ctorParameters = function () { return [
            { type: material.MatDialogRef },
            { type: undefined, decorators: [{ type: core.Inject, args: [material.MAT_DIALOG_DATA,] }] }
        ]; };
        ViewCredencialsDialogComponent.propDecorators = {
            onKeyUp: [{ type: core.HostListener, args: ['window:keyup.esc',] }]
        };
        return ViewCredencialsDialogComponent;
    }());
    if (false) {
        /** @type {?} */
        ViewCredencialsDialogComponent.prototype.data;
        /** @type {?} */
        ViewCredencialsDialogComponent.prototype.form;
        /** @type {?} */
        ViewCredencialsDialogComponent.prototype.dialogRef;
        /** @type {?} */
        ViewCredencialsDialogComponent.prototype.dataDialog;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function ChangeSecretDialogData() { }
    if (false) {
        /** @type {?} */
        ChangeSecretDialogData.prototype.id;
        /** @type {?} */
        ChangeSecretDialogData.prototype.service;
    }
    var ChangeSecretDialogComponent = /** @class */ (function () {
        function ChangeSecretDialogComponent(dialogRef, dataDialog, notificationservice, translateService) {
            this.dialogRef = dialogRef;
            this.dataDialog = dataDialog;
            this.notificationservice = notificationservice;
            this.translateService = translateService;
            this.disabledButton = false;
            this.id = this.dataDialog.id;
            this.service = this.dataDialog.service;
        }
        /**
         * @return {?}
         */
        ChangeSecretDialogComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        /**
         * @return {?}
         */
        ChangeSecretDialogComponent.prototype.change = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.disabledButton = true;
            this.service.generateSecret(this.id).subscribe((/**
             * @param {?} result
             * @return {?}
             */
            function (result) {
                /** @type {?} */
                var message = _this.translateService.instant('application_new_secret_success');
                _this.dialogRef.close({ success: true, clientId: result['clientId'], secret: result['secret'] });
                _this.notificationservice.showMessage('', message, commons.NotificationType.success);
                _this.disabledButton = false;
            }));
        };
        /**
         * @return {?}
         */
        ChangeSecretDialogComponent.prototype.closeDialog = /**
         * @return {?}
         */
        function () {
            this.dialogRef.close({ success: false });
        };
        /**
         * @return {?}
         */
        ChangeSecretDialogComponent.prototype.onKeyUp = /**
         * @return {?}
         */
        function () {
            this.dialogRef.close({ success: false });
        };
        ChangeSecretDialogComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-example-change-secret-dialog',
                        template: "<div class=\"close\">\n    <i class=\"fa fa-close\" (click)=\"closeDialog()\"></i>\n</div>\n<h1 mat-dialog-title class=\"dialog-title\">\n    <i class=\"fa fa-exclamation-triangle\"></i>{{ 'application_generated_secret_title' | translate}}\n</h1>\n<div mat-dialog-content class=\"dialog-content\">\n   <p>{{ 'application_generated_secret_message' | translate }}</p>\n</div>\n<div mat-dialog-actions class=\"border-top dialog-footer\">\n    <button type=\"button\" mat-button [disabled]=\"disabledButton\" (click)=\"closeDialog()\">{{'btn.no' | translate}} </button>\n    <button type=\"button\" mat-button [disabled]=\"disabledButton\" (click)=\"change()\">{{'btn.yes' | translate}} </button>\n</div>",
                        encapsulation: core.ViewEncapsulation.None,
                        styles: [".dialog-footer button{margin-top:10px}.dialog-content{color:#676a6c}.close{cursor:pointer;margin-top:-10px;font-size:15px}.dialog-title i{font-size:28px;padding-right:20px;color:red}"]
                    }] }
        ];
        /** @nocollapse */
        ChangeSecretDialogComponent.ctorParameters = function () { return [
            { type: material.MatDialogRef },
            { type: undefined, decorators: [{ type: core.Inject, args: [material.MAT_DIALOG_DATA,] }] },
            { type: commons.NotificationService },
            { type: core$1.TranslateService }
        ]; };
        ChangeSecretDialogComponent.propDecorators = {
            onKeyUp: [{ type: core.HostListener, args: ['window:keyup.esc',] }]
        };
        return ChangeSecretDialogComponent;
    }());
    if (false) {
        /** @type {?} */
        ChangeSecretDialogComponent.prototype.id;
        /** @type {?} */
        ChangeSecretDialogComponent.prototype.service;
        /** @type {?} */
        ChangeSecretDialogComponent.prototype.disabledButton;
        /** @type {?} */
        ChangeSecretDialogComponent.prototype.dialogRef;
        /** @type {?} */
        ChangeSecretDialogComponent.prototype.dataDialog;
        /**
         * @type {?}
         * @protected
         */
        ChangeSecretDialogComponent.prototype.notificationservice;
        /**
         * @type {?}
         * @protected
         */
        ChangeSecretDialogComponent.prototype.translateService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ChangeSecretDialogService = /** @class */ (function () {
        function ChangeSecretDialogService(dialog) {
            this.dialog = dialog;
        }
        /**
         * @param {?} id
         * @param {?} service
         * @return {?}
         */
        ChangeSecretDialogService.prototype.loadComponent = /**
         * @param {?} id
         * @param {?} service
         * @return {?}
         */
        function (id, service) {
            this.componentRef = this.dialog.open(ChangeSecretDialogComponent, {
                width: '500px',
                disableClose: true,
                data: {
                    id: id,
                    service: service
                }
            });
            return this.componentRef.afterClosed().pipe(operators.map((/**
             * @param {?} it
             * @return {?}
             */
            function (it) {
                return it;
            })));
        };
        ChangeSecretDialogService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        ChangeSecretDialogService.ctorParameters = function () { return [
            { type: material.MatDialog }
        ]; };
        /** @nocollapse */ ChangeSecretDialogService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function ChangeSecretDialogService_Factory() { return new ChangeSecretDialogService(core.ɵɵinject(dialog.MatDialog)); }, token: ChangeSecretDialogService, providedIn: "root" });
        return ChangeSecretDialogService;
    }());
    if (false) {
        /** @type {?} */
        ChangeSecretDialogService.prototype.answer;
        /** @type {?} */
        ChangeSecretDialogService.prototype.componentRef;
        /** @type {?} */
        ChangeSecretDialogService.prototype.dialog;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var basePath = "./service/application";
    var ApplicationService = /** @class */ (function () {
        function ApplicationService(http) {
            this.http = http;
        }
        /**
         * @param {?} id
         * @return {?}
         */
        ApplicationService.prototype.generateSecret = /**
         * @param {?} id
         * @return {?}
         */
        function (id) {
            return this.http.get(basePath + '/generate-secret/' + id);
        };
        ApplicationService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        ApplicationService.ctorParameters = function () { return [
            { type: http.HttpClient }
        ]; };
        /** @nocollapse */ ApplicationService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function ApplicationService_Factory() { return new ApplicationService(core.ɵɵinject(http.HttpClient)); }, token: ApplicationService, providedIn: "root" });
        return ApplicationService;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        ApplicationService.prototype.http;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ViewCredencialsDialogService = /** @class */ (function () {
        function ViewCredencialsDialogService(dialog) {
            this.dialog = dialog;
        }
        /**
         * @param {?} data
         * @return {?}
         */
        ViewCredencialsDialogService.prototype.loadComponent = /**
         * @param {?} data
         * @return {?}
         */
        function (data) {
            this.componentRef = this.dialog.open(ViewCredencialsDialogComponent, {
                width: '500px',
                disableClose: true,
                data: {
                    data: data
                }
            });
            return this.componentRef.afterClosed().pipe(operators.map((/**
             * @param {?} it
             * @return {?}
             */
            function (it) {
                return it;
            })));
        };
        ViewCredencialsDialogService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        ViewCredencialsDialogService.ctorParameters = function () { return [
            { type: material.MatDialog }
        ]; };
        /** @nocollapse */ ViewCredencialsDialogService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function ViewCredencialsDialogService_Factory() { return new ViewCredencialsDialogService(core.ɵɵinject(dialog.MatDialog)); }, token: ViewCredencialsDialogService, providedIn: "root" });
        return ViewCredencialsDialogService;
    }());
    if (false) {
        /** @type {?} */
        ViewCredencialsDialogService.prototype.answer;
        /** @type {?} */
        ViewCredencialsDialogService.prototype.componentRef;
        /** @type {?} */
        ViewCredencialsDialogService.prototype.dialog;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ApplicationFormComponent = /** @class */ (function (_super) {
        __extends(ApplicationFormComponent, _super);
        function ApplicationFormComponent(vcRef, route, router, dynaDataService, translate, notificationService, auditDialogService, confirmationDialogService, navigationService, validatorUtils, viewCredencialsService, changeSecretService, applicationService, init) {
            var _this = _super.call(this, vcRef, route, router, dynaDataService, translate, notificationService, auditDialogService, confirmationDialogService, init) || this;
            _this.vcRef = vcRef;
            _this.route = route;
            _this.router = router;
            _this.dynaDataService = dynaDataService;
            _this.translate = translate;
            _this.notificationService = notificationService;
            _this.auditDialogService = auditDialogService;
            _this.confirmationDialogService = confirmationDialogService;
            _this.navigationService = navigationService;
            _this.validatorUtils = validatorUtils;
            _this.viewCredencialsService = viewCredencialsService;
            _this.changeSecretService = changeSecretService;
            _this.applicationService = applicationService;
            _this.init = init;
            _this.statusOptions = {
                "styles": {
                    "A": "label label-primary",
                    "I": "label label-danger"
                }
            };
            _this.statusValues = [
                {
                    id: "A",
                    label: "application.status.active",
                    value: "A",
                    selected: false,
                },
                {
                    id: "I",
                    label: "application.status.inactive",
                    value: "I",
                    selected: false,
                }
            ];
            return _this;
        }
        /**
         * @return {?}
         */
        ApplicationFormComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            _super.prototype.ngOnInit.call(this);
        };
        /**
         * @return {?}
         */
        ApplicationFormComponent.prototype.submit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.processing = true;
            /** @type {?} */
            var keyVersion = "version";
            /** @type {?} */
            var version = this.record ? this.record[keyVersion] : undefined;
            this.record = this.form.value;
            /** @type {?} */
            var keyProps = Object.keys(this.record);
            keyProps.forEach((/**
             * @param {?} keyProp
             * @return {?}
             */
            function (keyProp) {
                /** @type {?} */
                var value = _this.record[keyProp];
                _this.record[keyProp] = gallery.Utilities.formatValue(_this.attributeTypes, keyProp, value);
            }));
            this.record[keyVersion] = version;
            if (this.mode === "new") {
                this.dynaDataService.create(this.record).subscribe((/**
                 * @param {?} it
                 * @return {?}
                 */
                function (it) {
                    /** @type {?} */
                    var title = _this.translate.instant("title.information");
                    /** @type {?} */
                    var message = _this.translate.instant("message.create.succesful");
                    _this.notificationService.showMessage(message, title, commons.NotificationType.success);
                    _this.dataDialog = _this.getDataDialog(it);
                    _this.viewCredencialsService.loadComponent(_this.dataDialog).subscribe((/**
                     * @param {?} result
                     * @return {?}
                     */
                    function (result) {
                        _this.record = new Object();
                        _this.form.reset();
                        _this.processing = false;
                    }));
                }), (/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) {
                    _this.processing = false;
                }));
            }
            else if (this.mode === "edit") {
                /** @type {?} */
                var record = this.record;
                /** @type {?} */
                var keyId = "id";
                record[keyId] = this.id;
                this.dynaDataService.update(this.id, record).subscribe((/**
                 * @param {?} it
                 * @return {?}
                 */
                function (it) {
                    /** @type {?} */
                    var title = _this.translate.instant("title.information");
                    /** @type {?} */
                    var message = _this.translate.instant("message.update.succesful");
                    _this.notificationService.showMessage(message, title, commons.NotificationType.success);
                    _this.processing = false;
                    _this.form.markAsPristine();
                    _this.router.navigate([_this.returnUrl]);
                }), (/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) {
                    _this.processing = false;
                }));
            }
        };
        /**
         * @private
         * @param {?} record
         * @return {?}
         */
        ApplicationFormComponent.prototype.getDataDialog = /**
         * @private
         * @param {?} record
         * @return {?}
         */
        function (record) {
            /** @type {?} */
            var data = record ? {
                clientId: record['clientId'],
                clientSecret: record['clientSecret'],
                accessTokenValidity: record['accessTokenValidity'],
                refreshTokenValidity: record['refreshTokenValidity']
            } : {};
            return data;
        };
        /**
         * @protected
         * @return {?}
         */
        ApplicationFormComponent.prototype.getFields = /**
         * @protected
         * @return {?}
         */
        function () {
            /** @type {?} */
            var form;
            /** @type {?} */
            var regex = /^http:\/\/\w+(\.\w+)*(:[0-9]+)?\/?(\/[.\w]*)*$/;
            if (this.record) {
                form = new forms.FormGroup({
                    id: new forms.FormControl({ value: this.record['id'], disabled: this.disabledCondition('id') }, forms.Validators.required),
                    identifier: new forms.FormControl({ value: this.record['identifier'], disabled: this.disabledCondition() }, [forms.Validators.required]),
                    description: new forms.FormControl({ value: this.record['description'], disabled: this.disabledCondition() }, forms.Validators.required),
                    redirectURL: new forms.FormControl({ value: this.record['redirectURL'], disabled: this.disabledCondition() }, [forms.Validators.required, forms.Validators.pattern(regex)]),
                    status: new forms.FormControl({ value: this.record['status'], disabled: true })
                });
            }
            else {
                form = new forms.FormGroup({
                    id: new forms.FormControl({ value: '', disabled: this.disabledCondition('id') }, forms.Validators.required),
                    identifier: new forms.FormControl({ value: '', disabled: this.disabledCondition() }, forms.Validators.required),
                    description: new forms.FormControl({ value: '', disabled: this.disabledCondition() }, forms.Validators.required),
                    redirectURL: new forms.FormControl({ value: '', disabled: this.disabledCondition() }, [forms.Validators.required, forms.Validators.pattern(regex)]),
                    status: new forms.FormControl()
                });
            }
            this.dataDialog = this.getDataDialog(this.record);
            return form;
        };
        /**
         * @param {?=} controlName
         * @return {?}
         */
        ApplicationFormComponent.prototype.disabledCondition = /**
         * @param {?=} controlName
         * @return {?}
         */
        function (controlName) {
            /** @type {?} */
            var disabled = this.mode === "view" || controlName === "id";
            return disabled;
        };
        /**
         * @return {?}
         */
        ApplicationFormComponent.prototype.changeSecret = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.changeSecretService.loadComponent(this.id, this.applicationService).subscribe((/**
             * @param {?} result
             * @return {?}
             */
            function (result) {
                if (result['success']) {
                    _this.dataDialog['clientSecret'] = result['secret'];
                    _this.dataDialog['clientId'] = result['clientId'];
                }
            }));
        };
        /**
         * @return {?}
         */
        ApplicationFormComponent.prototype.showCredentials = /**
         * @return {?}
         */
        function () {
            this.viewCredencialsService.loadComponent(this.dataDialog).subscribe((/**
             * @param {?} result
             * @return {?}
             */
            function (result) { }));
        };
        ApplicationFormComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-example-application-form',
                        template: "<form [formGroup]=\"form\" name=\"form\" autocomplete=\"off\" novalidate (ngSubmit)=\"submit()\">\n    <div class=\"row\">\n        <div class=\"col-12\">\n            <div class=\"mail-box-header detail-header\">\n                <xdf-form-header title_=\"application.title\" [icon]=\"icon\" [recordIdentifier]=\"record?.identifier\"\n                    [mode]=\"mode\" [resourceAuth]=\"resourceAuth\" (optionEvent)=\"optionEvent($event)\"\n                    [editing]=\"mode === 'edit'\" [displaying]=\"mode === 'view'\">\n                </xdf-form-header>\n            </div>\n\n            <div class=\"mail-box-content\">\n                <div class=\"row\">\n                    <div class=\"col-12\">\n                        <div class=\"form-content\">\n                            <div class=\"group-content\">\n                                <div class=\"legend\">\n                                    <span class=\"group-title\">{{ 'application_group_general_information' | translate }}</span>\n                                    \n                                    <div class=\"pull-right application-options\" *ngIf=\"mode !== 'new'\">\n                                        <button type=\"button\" class=\"btn btn-default btn-sm\" (click)=\"changeSecret()\"\n                                            *ngIf=\"mode !== 'view'\"><span\n                                                class=\"btn-label\">{{ 'application_btn_new_secret' |translate }}</span></button>\n                                        <button type=\"button\" class=\"btn btn-default btn-sm\"\n                                            (click)=\"showCredentials()\"><span\n                                                class=\"btn-label\">{{ 'application_btn_show_credentials' |translate }}</span></button>\n                                    </div>\n                                </div>\n                                <div class=\"row\">\n                                    <div class=\"form-group col-6\">\n                                        <xdf-input name=\"identifier\" label=\"application_form_identifier_placeholder\"\n                                            type=\"text\" [required]=\"true\"\n                                            placeholder=\"application_form_identifier_placeholder\" [formGroup]=\"form\"\n                                            [options]=\"{'maxLength': 20, 'showLength': true}\">\n                                        </xdf-input>\n                                    </div>\n                                    <div class=\"form-group col-6\">\n                                        <xdf-badge name=\"status\" [values]=\"statusValues\"\n                                            formControlName=\"status\" [options]=\"statusOptions\">\n                                        </xdf-badge>\n                                    </div>\n                                </div>\n                                <div class=\"row\">\n                                    <div class=\"form-group col-6\">\n                                        <xdf-input name=\"description\" label=\"application_form_description_placeholder\"\n                                            type=\"text\" [required]=\"true\"\n                                            placeholder=\"application_form_description_placeholder\" [formGroup]=\"form\"\n                                            [options]=\"{'maxLength': 100, 'showLength': true}\">\n                                        </xdf-input>\n\n                                    </div>\n                                    <div class=\"form-group col-6\">\n                                        <xdf-input name=\"redirectURL\" label=\"application_form_redirectURL_placeholder\"\n                                            type=\"text\" [required]=\"true\"\n                                            placeholder=\"application_form_redirectURL_placeholder\" [formGroup]=\"form\"\n                                            [options]=\"{'maxLength': 100, 'showLength': true}\">\n                                        </xdf-input>\n                                    </div>\n                                </div>\n                            </div>\n                        </div>\n                    </div>\n                </div>\n                <div class=\"row\">\n                    <div class=\"col-lg-12\" *ngIf=\"mode !== 'view'\">\n                        <div class=\"form-status-bar border-top\">\n                            <button type=\"submit\" mat-stroked-button class=\"btn btn-primary\"\n                                [disabled]=\"form?.invalid || processing\">\n                                <i class=\"fa fa-save\" aria-hidden=\"true\"></i>{{'btn.save' | translate}}\n                            </button>\n                        </div>\n                    </div>\n                </div>\n            </div>\n        </div>\n    </div>\n</form>",
                        styles: [".form-status-bar{padding:10px 0}.form-status-bar button{color:#fff;font-size:12px;float:right;font-weight:500}.form-status-bar button i{padding-right:5px}.form-content{margin:10px 20px}.label-access{padding-bottom:7px}.application-options button{color:#676a6c;font-size:10px!important}"]
                    }] }
        ];
        /** @nocollapse */
        ApplicationFormComponent.ctorParameters = function () { return [
            { type: core.ViewContainerRef },
            { type: router.ActivatedRoute },
            { type: router.Router },
            { type: gallery.DynaDataService },
            { type: core$1.TranslateService },
            { type: commons.NotificationService },
            { type: gallery.AuditDialogService },
            { type: gallery.ConfirmationDialogService },
            { type: layouts.NavigationService },
            { type: gallery.ValidatorUtils },
            { type: ViewCredencialsDialogService },
            { type: ChangeSecretDialogService },
            { type: ApplicationService },
            { type: commons.InitCommonsService }
        ]; };
        return ApplicationFormComponent;
    }(gallery.IFormView));
    if (false) {
        /** @type {?} */
        ApplicationFormComponent.prototype.dataDialog;
        /** @type {?} */
        ApplicationFormComponent.prototype.statusOptions;
        /** @type {?} */
        ApplicationFormComponent.prototype.statusValues;
        /**
         * @type {?}
         * @protected
         */
        ApplicationFormComponent.prototype.vcRef;
        /**
         * @type {?}
         * @protected
         */
        ApplicationFormComponent.prototype.route;
        /**
         * @type {?}
         * @protected
         */
        ApplicationFormComponent.prototype.router;
        /**
         * @type {?}
         * @protected
         */
        ApplicationFormComponent.prototype.dynaDataService;
        /**
         * @type {?}
         * @protected
         */
        ApplicationFormComponent.prototype.translate;
        /**
         * @type {?}
         * @protected
         */
        ApplicationFormComponent.prototype.notificationService;
        /**
         * @type {?}
         * @protected
         */
        ApplicationFormComponent.prototype.auditDialogService;
        /**
         * @type {?}
         * @protected
         */
        ApplicationFormComponent.prototype.confirmationDialogService;
        /**
         * @type {?}
         * @protected
         */
        ApplicationFormComponent.prototype.navigationService;
        /**
         * @type {?}
         * @protected
         */
        ApplicationFormComponent.prototype.validatorUtils;
        /**
         * @type {?}
         * @protected
         */
        ApplicationFormComponent.prototype.viewCredencialsService;
        /**
         * @type {?}
         * @protected
         */
        ApplicationFormComponent.prototype.changeSecretService;
        /**
         * @type {?}
         * @protected
         */
        ApplicationFormComponent.prototype.applicationService;
        /**
         * @type {?}
         * @protected
         */
        ApplicationFormComponent.prototype.init;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ValposFormComponent = /** @class */ (function (_super) {
        __extends(ValposFormComponent, _super);
        function ValposFormComponent(vcRef, route, router, dynaDataService, translate, notificationService, auditDialogService, confirmationDialogService, navigationService, validatorUtils, fb, cdr, init) {
            var _this = _super.call(this, vcRef, route, router, dynaDataService, translate, notificationService, auditDialogService, confirmationDialogService, init) || this;
            _this.vcRef = vcRef;
            _this.route = route;
            _this.router = router;
            _this.dynaDataService = dynaDataService;
            _this.translate = translate;
            _this.notificationService = notificationService;
            _this.auditDialogService = auditDialogService;
            _this.confirmationDialogService = confirmationDialogService;
            _this.navigationService = navigationService;
            _this.validatorUtils = validatorUtils;
            _this.fb = fb;
            _this.cdr = cdr;
            _this.init = init;
            _this.prefix = 'valpos';
            _this.displayedColumns = ['label', 'value'];
            _this.dataSource = new rxjs.BehaviorSubject([]);
            return _this;
        }
        /**
         * @return {?}
         */
        ValposFormComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            _super.prototype.ngOnInit.call(this);
            this.tableDefinition = this.route.snapshot.data.editableTableTemplate;
        };
        /**
         * @return {?}
         */
        ValposFormComponent.prototype.ngAfterContentChecked = /**
         * @return {?}
         */
        function () {
            this.cdr.detectChanges();
        };
        /**
         * @protected
         * @return {?}
         */
        ValposFormComponent.prototype.receiveResult = /**
         * @protected
         * @return {?}
         */
        function () {
            var _this = this;
            this.data = this.record['detail'];
            if (this.data) {
                this.sortOrder();
                this.data.forEach((/**
                 * @param {?} d
                 * @return {?}
                 */
                function (d) { return _this.addRow(d, false); }));
                this.updateGrid();
            }
        };
        /**
         * @param {?} d
         * @param {?=} noUpdate
         * @return {?}
         */
        ValposFormComponent.prototype.addRow = /**
         * @param {?} d
         * @param {?=} noUpdate
         * @return {?}
         */
        function (d, noUpdate) {
            /** @type {?} */
            var row = this.fb.group({
                'id': [{ value: d && d.id ? d.id : null, disabled: this.mode === "view" }, []],
                'order': [{ value: d && d.order ? d.order : 0, disabled: this.mode === "view" }, []],
                'label': [{ value: d && d.label ? d.label : null, disabled: this.mode === "view" }, []],
                'value': [{ value: d && d.value ? d.value : null, disabled: this.mode === "view" }, []],
            });
            this.detailForm.push(row);
            if (!noUpdate) {
                this.updateGrid();
            }
        };
        /**
         * @return {?}
         */
        ValposFormComponent.prototype.submit = /**
         * @return {?}
         */
        function () {
            if (this.record) {
                this.form.value['identifier'] = this.record['identifier'];
            }
            _super.prototype.submit.call(this);
        };
        /**
         * @param {?} option
         * @return {?}
         */
        ValposFormComponent.prototype.optionEvent = /**
         * @param {?} option
         * @return {?}
         */
        function (option) {
            var _this = this;
            _super.prototype.optionEvent.call(this, option);
            if (option === 'edit' || option === 'new') {
                this.mode = option;
                this.updateGrid(option === 'new');
                if (option === 'edit') {
                    /** @type {?} */
                    var value = __spread(this.detailForm.value);
                    this.detailForm.clear();
                    value.forEach((/**
                     * @param {?} item
                     * @return {?}
                     */
                    function (item) {
                        _this.addRow(item);
                    }));
                    this.table.updateGrid();
                }
            }
        };
        /**
         * @protected
         * @return {?}
         */
        ValposFormComponent.prototype.getFields = /**
         * @protected
         * @return {?}
         */
        function () {
            /** @type {?} */
            var form;
            if (this.record) {
                form = new forms.FormGroup({
                    identifier: new forms.FormControl({ value: this.record['identifier'], disabled: this.mode !== "new" }, [forms.Validators.required]),
                    description: new forms.FormControl({ value: this.record['description'], disabled: this.mode === "view" }, [forms.Validators.required]),
                    detail: this.detailForm
                });
            }
            else {
                this.detailForm = this.fb.array([]);
                form = new forms.FormGroup({
                    identifier: new forms.FormControl({ value: '', disabled: false }, [forms.Validators.required]),
                    description: new forms.FormControl({ value: '', disabled: false }, [forms.Validators.required]),
                    detail: this.detailForm
                });
            }
            return form;
        };
        /**
         * @param {?=} clearData
         * @return {?}
         */
        ValposFormComponent.prototype.updateGrid = /**
         * @param {?=} clearData
         * @return {?}
         */
        function (clearData) {
            if (clearData) {
                this.detailForm.clear();
            }
            this.dataSource.next(this.detailForm.controls);
        };
        /**
         * @param {?} $event
         * @return {?}
         */
        ValposFormComponent.prototype.optionClicked = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            if ($event.action === 'add') {
                this.addRow(null, false);
                this.sortOrder();
            }
            else if ($event.action === 'delete') {
                this.detailForm.removeAt($event['index']);
                this.updateGrid();
                this.sortOrder();
            }
        };
        /**
         * @return {?}
         */
        ValposFormComponent.prototype.sortOrder = /**
         * @return {?}
         */
        function () {
            this.detailForm.controls.forEach((/**
             * @param {?} item
             * @param {?} index
             * @return {?}
             */
            function (item, index) {
                /** @type {?} */
                var formControl = (/** @type {?} */ (item.controls['order']));
                formControl.setValue(index);
            }));
        };
        /**
         * @protected
         * @return {?}
         */
        ValposFormComponent.prototype.postActionNew = /**
         * @protected
         * @return {?}
         */
        function () {
            this.updateGrid(true);
        };
        ValposFormComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-example-valpos-form',
                        template: "<form [formGroup]=\"form\" name=\"form\" autocomplete=\"off\" novalidate (ngSubmit)=\"submit()\">\n    <div class=\"row\">\n        <div class=\"col-12\">\n            <div class=\"mail-box-header detail-header\">\n                <xdf-form-header title_=\"valpos.title\" [icon]=\"icon\" [recordIdentifier]=\"record?.identifier\"\n                    [mode]=\"mode\" [resourceAuth]=\"resourceAuth\" (optionEvent)=\"optionEvent($event)\"\n                    [editing]=\"mode === 'edit'\" [displaying]=\"mode === 'view'\">\n                </xdf-form-header>\n            </div>\n\n            <div class=\"mail-box-content\">\n                <div class=\"row\">\n                    <div class=\"col-12\">\n                        <div class=\"form-content\">\n                            <div class=\"legend\">\n                                <span class=\"group-title\">{{ 'valpos_group_general_information' | translate }}</span>\n                            </div>\n                            <div class=\"group-content\">\n                                <div class=\"row\">\n                                    <div class=\"form-group col-6\">\n                                        <xdf-input name=\"identifier\" label=\"valpos_form_identifier_placeholder\"\n                                            type=\"text\" [required]=\"true\"\n                                            placeholder=\"valpos_form_identifier_placeholder\" [formGroup]=\"form\"\n                                            [options]=\"{'maxLength': 20, 'showLength': true}\">\n                                        </xdf-input>\n                                    </div>\n                                    <div class=\"form-group col-6\">\n                                        <xdf-input name=\"description\" label=\"valpos_form_description_placeholder\"\n                                            type=\"text\" [required]=\"true\"\n                                            placeholder=\"valpos_form_description_placeholder\" [formGroup]=\"form\"\n                                            [options]=\"{'maxLength': 100, 'showLength': true}\">\n                                        </xdf-input>\n\n                                    </div>\n                                </div>\n                            </div>\n                        </div>\n                    </div>\n                    <div class=\"col-12\">\n                        <div class=\"form-content\">\n                            <div class=\"group-content\">\n                                <div class=\"row\">\n                                    <div class=\"form-group col-12\">\n                                        <xdf-editable-data-table #table \n                                            titleHeader=\"{{ 'valpos_group_values' | translate }}\"\n                                            [prefix]=\"prefix\" formArrayName=\"detail\" [form]=\"form\"\n                                            [displayedColumns]=\"displayedColumns\" [mode]=\"mode\"\n                                            [definition]=\"tableDefinition\" [dataSource]=\"dataSource\"\n                                            (optionClicked)=\"optionClicked($event)\" (onSortEvent)=\"sortOrder()\"></xdf-editable-data-table>\n                                    </div>\n                                </div>\n                            </div>\n                        </div>\n                    </div>\n                </div>\n                <div class=\"row\">\n                    <div class=\"col-lg-12\" *ngIf=\"mode !== 'view'\">\n                        <div class=\"form-status-bar border-top\">\n                            <button type=\"submit\" mat-stroked-button class=\"btn btn-primary\"\n                                [disabled]=\"form?.invalid || processing\">\n                                <i class=\"fa fa-save\" aria-hidden=\"true\"></i>{{'btn.save' | translate}}\n                            </button>\n                        </div>\n                    </div>\n                </div>\n            </div>\n        </div>\n    </div>\n</form>",
                        styles: [".form-status-bar{padding:10px 0}.form-status-bar button{color:#fff;font-size:12px;float:right;font-weight:500}.form-status-bar button i{padding-right:5px}.form-content{margin:10px 20px}::ng-deep .text-full-width{width:80%}"]
                    }] }
        ];
        /** @nocollapse */
        ValposFormComponent.ctorParameters = function () { return [
            { type: core.ViewContainerRef },
            { type: router.ActivatedRoute },
            { type: router.Router },
            { type: gallery.DynaDataService },
            { type: core$1.TranslateService },
            { type: commons.NotificationService },
            { type: gallery.AuditDialogService },
            { type: gallery.ConfirmationDialogService },
            { type: layouts.NavigationService },
            { type: gallery.ValidatorUtils },
            { type: forms.FormBuilder },
            { type: core.ChangeDetectorRef },
            { type: commons.InitCommonsService }
        ]; };
        ValposFormComponent.propDecorators = {
            table: [{ type: core.ViewChild, args: ['table', { static: false },] }]
        };
        return ValposFormComponent;
    }(gallery.IFormView));
    if (false) {
        /** @type {?} */
        ValposFormComponent.prototype.table;
        /** @type {?} */
        ValposFormComponent.prototype.prefix;
        /** @type {?} */
        ValposFormComponent.prototype.displayedColumns;
        /** @type {?} */
        ValposFormComponent.prototype.tableDefinition;
        /** @type {?} */
        ValposFormComponent.prototype.data;
        /** @type {?} */
        ValposFormComponent.prototype.dataSource;
        /** @type {?} */
        ValposFormComponent.prototype.detailForm;
        /**
         * @type {?}
         * @protected
         */
        ValposFormComponent.prototype.vcRef;
        /**
         * @type {?}
         * @protected
         */
        ValposFormComponent.prototype.route;
        /**
         * @type {?}
         * @protected
         */
        ValposFormComponent.prototype.router;
        /**
         * @type {?}
         * @protected
         */
        ValposFormComponent.prototype.dynaDataService;
        /**
         * @type {?}
         * @protected
         */
        ValposFormComponent.prototype.translate;
        /**
         * @type {?}
         * @protected
         */
        ValposFormComponent.prototype.notificationService;
        /**
         * @type {?}
         * @protected
         */
        ValposFormComponent.prototype.auditDialogService;
        /**
         * @type {?}
         * @protected
         */
        ValposFormComponent.prototype.confirmationDialogService;
        /**
         * @type {?}
         * @protected
         */
        ValposFormComponent.prototype.navigationService;
        /**
         * @type {?}
         * @protected
         */
        ValposFormComponent.prototype.validatorUtils;
        /**
         * @type {?}
         * @private
         */
        ValposFormComponent.prototype.fb;
        /**
         * @type {?}
         * @private
         */
        ValposFormComponent.prototype.cdr;
        /**
         * @type {?}
         * @protected
         */
        ValposFormComponent.prototype.init;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var UserRoleAccessComponent = /** @class */ (function () {
        function UserRoleAccessComponent() {
            this.onChangeSelection = new core.EventEmitter();
            this.items = new forms.FormArray([]);
            this.formArrayGroup = new forms.FormGroup({
                items: this.items
            });
        }
        /**
         * @return {?}
         */
        UserRoleAccessComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.initForm();
        };
        /**
         * @return {?}
         */
        UserRoleAccessComponent.prototype.ngOnChanges = /**
         * @return {?}
         */
        function () {
        };
        /**
         * @return {?}
         */
        UserRoleAccessComponent.prototype.initForm = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.items.clear();
            this.data.forEach((/**
             * @param {?} program
             * @return {?}
             */
            function (program) {
                /** @type {?} */
                var programFormGroup = _this.initFormGroup(program, 'program');
                /** @type {?} */
                var controlFormArray = (/** @type {?} */ (programFormGroup.controls['controls']));
                if (program.controls && program.controls.length > 0) {
                    _this.initControls(controlFormArray, program.controls);
                    programFormGroup.controls['allow'].setValue(_this.mode === 'new' ? false : _this.isAtLeastOneSelected(controlFormArray));
                }
                _this.items.push(programFormGroup);
            }));
        };
        /**
         * @param {?} item
         * @param {?=} attrName
         * @return {?}
         */
        UserRoleAccessComponent.prototype.initFormGroup = /**
         * @param {?} item
         * @param {?=} attrName
         * @return {?}
         */
        function (item, attrName) {
            /** @type {?} */
            var formGroup = new forms.FormGroup({});
            formGroup.addControl(attrName, new forms.FormControl(item[attrName]));
            formGroup.addControl(attrName + 'Id', new forms.FormControl(item[attrName + 'Id']));
            formGroup.addControl('allow', new forms.FormControl({ value: this.mode === 'new' ? false : item.allow, disabled: this.disabled }));
            if (attrName !== 'control') {
                formGroup.addControl('label', new forms.FormControl({ value: item.label, disabled: true }));
                formGroup.addControl('controls', new forms.FormArray([]));
            }
            return formGroup;
        };
        /**
         * @param {?} programControls
         * @param {?} controls
         * @return {?}
         */
        UserRoleAccessComponent.prototype.initControls = /**
         * @param {?} programControls
         * @param {?} controls
         * @return {?}
         */
        function (programControls, controls) {
            var _this = this;
            controls.forEach((/**
             * @param {?} control
             * @return {?}
             */
            function (control) {
                /** @type {?} */
                var formGroupControl = _this.initFormGroup(control, 'control');
                programControls.push(formGroupControl);
            }));
        };
        Object.defineProperty(UserRoleAccessComponent.prototype, "disabled", {
            get: /**
             * @private
             * @return {?}
             */
            function () {
                return (this.mode === "view");
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} isProgram
         * @param {?=} controlForm
         * @return {?}
         */
        UserRoleAccessComponent.prototype.updateselection = /**
         * @param {?} isProgram
         * @param {?=} controlForm
         * @return {?}
         */
        function (isProgram, controlForm) {
            if (isProgram) {
                /** @type {?} */
                var controlsFormArray = (/** @type {?} */ (controlForm.controls['controls']));
                controlsFormArray.controls.forEach((/**
                 * @param {?} controlFormGroup
                 * @return {?}
                 */
                function (controlFormGroup) {
                    controlFormGroup.controls['allow'].setValue(controlForm.controls['allow'].value);
                }));
            }
            else {
                /** @type {?} */
                var controlsFormArray = (/** @type {?} */ (controlForm.controls['controls']));
                controlForm.controls['allow'].setValue(this.isAtLeastOneSelected(controlsFormArray));
            }
            this.onChangeSelection.emit(true);
        };
        /**
         * @param {?} controls
         * @return {?}
         */
        UserRoleAccessComponent.prototype.isAtLeastOneSelected = /**
         * @param {?} controls
         * @return {?}
         */
        function (controls) {
            for (var index in controls.controls) {
                /** @type {?} */
                var control = (/** @type {?} */ (controls.controls[index]));
                if (control.controls['allow'].value) {
                    return true;
                }
            }
            return false;
        };
        /**
         * @param {?} item
         * @return {?}
         */
        UserRoleAccessComponent.prototype.open = /**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            if (item['open'] == undefined) {
                item['open'] = false;
            }
            else {
                item['open'] = !item['open'];
            }
        };
        UserRoleAccessComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-user-role-access',
                        template: "<div class=\"panel panel-default\" [formGroup]=\"formArrayGroup\">\n    <div class=\"slimScrollDiv\" style=\"height: 234px;\" formArrayName=\"items\">\n        <ng-scrollbar>\n            <table class=\"table table-no-border\">\n                <tbody *ngFor=\"let program of items.controls; index as i\" [formGroupName]=\"i\">\n                    <tr class=\"border-bottom\">\n                        <td style=\"width:15px;padding-left: 15px;\">\n                            <mat-checkbox formControlName=\"allow\" (change)=\"updateselection(true, program)\">\n                            </mat-checkbox>\n                        </td>\n                        <td>\n                            <!-- <i class=\"fa {{program.controls['icon'].value}}\"></i> -->\n                            &nbsp;<span>{{ program.controls['label'].value | translate }}</span>\n                        </td>\n                        <td style=\"padding-right: 30px; text-align: right;\">\n                            <div class=\"close\">\n                                <i class=\"fa fa-minus-circle fa-1x fa-1-5\"\n                                    [ngClass]=\"{'fa-minus-circle': (program.open || program?.open === undefined), 'fa-plus-circle': !program.open}\"\n                                    (click)=\"open(program)\"></i>\n                            </div>\n                        </td>\n                    </tr>\n                    <ng-container formArrayName=\"controls\" *ngIf=\"program?.open || program?.open === undefined\">\n                        <tr *ngFor=\"let control of program.get('controls').controls; index as k\">\n                            <td></td>\n                            <td colspan=\"2\" style=\"padding: 0px;\">\n                                <table class=\"table table-no-border table-second-level\" [formGroupName]=\"k\">\n                                    <tbody>\n                                        <tr>\n                                            <td style=\"width:15px\">\n                                                <mat-checkbox formControlName=\"allow\" (change)=\"updateselection(false, program)\"></mat-checkbox>\n                                            </td>\n                                            <td><span>{{ 'control.' + control.controls['control'].value | translate}}</span></td>\n                                            <td style=\"width: 25px;\">\n                                            </td>\n                                        </tr>\n                                    </tbody>\n                                </table>\n                            </td>\n                        </tr>\n                    </ng-container>\n                </tbody>\n            </table>\n        </ng-scrollbar>\n    </div>\n</div>",
                        styles: [".panel table{color:#676a6c!important}.panel table tbody .close{height:18px;line-height:18px}.close{cursor:pointer}.table>tbody>tr>td,.table>tbody>tr>th,.table>tfoot>tr>td,.table>tfoot>tr>th,.table>thead>tr>td,.table>thead>tr>th{padding:6px}table tbody+tbody{border-top:0 solid #dee2e6}.table-second-level{margin-bottom:0}.table-no-border>tbody>tr>td{border-top-style:none}.fa-1-5{font-size:18px}"]
                    }] }
        ];
        /** @nocollapse */
        UserRoleAccessComponent.ctorParameters = function () { return []; };
        UserRoleAccessComponent.propDecorators = {
            data: [{ type: core.Input }],
            mode: [{ type: core.Input }],
            onChangeSelection: [{ type: core.Output }]
        };
        return UserRoleAccessComponent;
    }());
    if (false) {
        /** @type {?} */
        UserRoleAccessComponent.prototype.data;
        /** @type {?} */
        UserRoleAccessComponent.prototype.mode;
        /** @type {?} */
        UserRoleAccessComponent.prototype.onChangeSelection;
        /** @type {?} */
        UserRoleAccessComponent.prototype.formArrayGroup;
        /** @type {?} */
        UserRoleAccessComponent.prototype.items;
        /** @type {?} */
        UserRoleAccessComponent.prototype.programsArray;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Program = /** @class */ (function () {
        function Program(name) {
            this.allow = false;
            this.name = name;
        }
        return Program;
    }());
    if (false) {
        /** @type {?} */
        Program.prototype.name;
        /** @type {?} */
        Program.prototype.controls;
        /** @type {?} */
        Program.prototype.allow;
    }
    var Control = /** @class */ (function () {
        function Control(name) {
            this.name = name;
        }
        return Control;
    }());
    if (false) {
        /** @type {?} */
        Control.prototype.name;
        /** @type {?} */
        Control.prototype.allow;
    }
    var UserRoleFormComponent = /** @class */ (function (_super) {
        __extends(UserRoleFormComponent, _super);
        function UserRoleFormComponent(vcRef, route, router, dynaDataService, translate, notificationService, auditDialogService, confirmationDialogService, navigationService, init) {
            var _this = _super.call(this, vcRef, route, router, dynaDataService, translate, notificationService, auditDialogService, confirmationDialogService, init) || this;
            _this.vcRef = vcRef;
            _this.route = route;
            _this.router = router;
            _this.dynaDataService = dynaDataService;
            _this.translate = translate;
            _this.notificationService = notificationService;
            _this.auditDialogService = auditDialogService;
            _this.confirmationDialogService = confirmationDialogService;
            _this.navigationService = navigationService;
            _this.init = init;
            _this.data = [];
            _this.icon = '<span class="material-icons fa-1_5x">supervisor_account</span>';
            _this.serviceURL = "./service/user-role";
            _this.dirtyAccessDetail = false;
            return _this;
        }
        /**
         * @return {?}
         */
        UserRoleFormComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            _super.prototype.ngOnInit.call(this);
            this.data = (/** @type {?} */ (this.route.snapshot.data['accessList']));
            this.data.forEach((/**
             * @param {?} program
             * @return {?}
             */
            function (program) {
                program.allow = false;
            }));
        };
        /**
         * @return {?}
         */
        UserRoleFormComponent.prototype.submit = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var formValue = this.form.value;
            formValue['accessList'] = this.access.formArrayGroup.value['items'];
            _super.prototype.submit.call(this);
        };
        /**
         * @protected
         * @return {?}
         */
        UserRoleFormComponent.prototype.getFields = /**
         * @protected
         * @return {?}
         */
        function () {
            /** @type {?} */
            var form;
            if (this.record) {
                form = new forms.FormGroup({
                    id: new forms.FormControl({ value: this.record['id'], disabled: this.disabledCondition('id') }, forms.Validators.required),
                    identifier: new forms.FormControl({ value: this.record['identifier'], disabled: this.disabledCondition() }, forms.Validators.required),
                    description: new forms.FormControl({ value: this.record['description'], disabled: this.disabledCondition() }, forms.Validators.required),
                });
            }
            else {
                form = new forms.FormGroup({
                    id: new forms.FormControl({ value: '', disabled: this.disabledCondition('id') }, forms.Validators.required),
                    identifier: new forms.FormControl({ value: '', disabled: this.disabledCondition() }, forms.Validators.required),
                    description: new forms.FormControl({ value: '', disabled: this.disabledCondition() }, forms.Validators.required)
                });
            }
            if (this.access) {
                this.access.mode = this.mode;
                this.access.initForm();
            }
            return form;
        };
        /**
         * @protected
         * @param {?=} controlName
         * @return {?}
         */
        UserRoleFormComponent.prototype.disabledCondition = /**
         * @protected
         * @param {?=} controlName
         * @return {?}
         */
        function (controlName) {
            /** @type {?} */
            var disabled = this.mode === 'view' || controlName === 'id';
            return disabled;
        };
        /**
         * @protected
         * @return {?}
         */
        UserRoleFormComponent.prototype.postActionNew = /**
         * @protected
         * @return {?}
         */
        function () {
            this.data.forEach((/**
             * @param {?} program
             * @return {?}
             */
            function (program) {
                program.allow = false;
                if (program.controls) {
                    program.controls.forEach((/**
                     * @param {?} control
                     * @return {?}
                     */
                    function (control) {
                        control.allow = false;
                    }));
                }
            }));
            this.access.initForm();
            this.dirtyAccessDetail = false;
        };
        /**
         * @return {?}
         */
        UserRoleFormComponent.prototype.updateDirty = /**
         * @return {?}
         */
        function () {
            this.dirtyAccessDetail = true;
        };
        /**
         * @return {?}
         */
        UserRoleFormComponent.prototype.isDirty = /**
         * @return {?}
         */
        function () {
            return this.form.dirty || this.dirtyAccessDetail;
        };
        UserRoleFormComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-user-role-form',
                        template: "\n<form [formGroup]=\"form\" name=\"form\" autocomplete=\"off\" novalidate (ngSubmit)=\"submit()\">\n    <div class=\"row\">\n        <div class=\"col-12\">\n            <div class=\"mail-box-header detail-header\">\n                <xdf-form-header [icon]=\"icon\" title_=\"user.role.title\" \n                    titleDesc=\"user.role.title.desc\" [recordIdentifier]=\"record?.identifier\" [mode]=\"mode\"\n                    [resourceAuth]=\"resourceAuth\" (optionEvent)=\"optionEvent($event)\"\n                    [editing]=\"mode === 'edit'\" [displaying]=\"mode === 'view'\">\n                </xdf-form-header>\n            </div>\n\n            <div class=\"mail-box-content\">\n                <div class=\"row\">\n                    <div class=\"col-12\">\n                        <div class=\"form-content\">\n                            \n                            <div class=\"legend\">\n                                <span class=\"group-title\">{{ 'user_role_group_info_header' | translate}}</span>\n                            </div>\n                            \n                            <div class=\"group-content\">\n                                <div class=\"row\" *ngIf=\"mode !== 'new'\">\n                                    <div class=\"form-group col-6\">\n                                        <xdf-input name=\"id\" label=\"user_role_form_id\" \n                                            type=\"text\" [required]=\"true\"\n                                            placeholder=\"user_role_form_id_placeholder\" \n                                            [formGroup]=\"form\">\n                                        </xdf-input>\n                                    </div>\n                                </div>\n                                <div class=\"row\">\n                                    <div class=\"form-group col-6\">\n                                        <xdf-input name=\"identifier\" label=\"user_role_form_identifier\" \n                                            type=\"text\" [required]=\"true\"\n                                            placeholder=\"user_role_form_identifier_placeholder\" \n                                            [formGroup]=\"form\"\n                                            [options]=\"{'maxLength': 20, 'showLength': true}\">\n                                        </xdf-input>\n                                    </div>\n                                    <div class=\"form-group col-6\">\n                                        <xdf-input name=\"description\" label=\"user_role_form_description\" \n                                            type=\"text\" [required]=\"true\"\n                                            placeholder=\"user_role_form_description_placeholder\" \n                                            [formGroup]=\"form\">\n                                        </xdf-input>\n                                        \n                                    </div>\n                                </div>\n                                <div class=\"row\">\n                                    <div class=\"col-lg-12 label-access\">\n                                        <span>{{'Accesos por rol' | translate}}</span>\n                                    </div>\n                                    <xdf-user-role-access #access class=\"col-lg-12\" [data]=\"data\" [mode]=\"mode\" (onChangeSelection)=\"updateDirty()\"></xdf-user-role-access>\n                                </div>\n                            </div> \n                        </div>\n                    </div>\n\n                    \n                </div>\n                <div class=\"row\">\n                    <div class=\"col-lg-12\" *ngIf=\"mode !== 'view'\">\n                        <div class=\"form-status-bar border-top\">\n                            <button type=\"submit\" mat-stroked-button class=\"btn btn-primary\" [disabled]=\"form?.invalid || processing\">\n                                <i class=\"fa fa-save\" aria-hidden=\"true\"></i>{{'btn.save' | translate}}\n                            </button>\n                        </div>\n                    </div>\n                </div>\n            </div>\n        </div>\n    </div>\n</form>",
                        styles: [".form-status-bar{padding:10px 0}.form-status-bar button{color:#fff;font-size:12px;float:right;font-weight:500}.form-status-bar button i{padding-right:5px}.form-content{margin:10px 20px}.label-access{padding-bottom:7px}"]
                    }] }
        ];
        /** @nocollapse */
        UserRoleFormComponent.ctorParameters = function () { return [
            { type: core.ViewContainerRef },
            { type: router.ActivatedRoute },
            { type: router.Router },
            { type: gallery.DynaDataService },
            { type: core$1.TranslateService },
            { type: commons.NotificationService },
            { type: gallery.AuditDialogService },
            { type: gallery.ConfirmationDialogService },
            { type: layouts.NavigationService },
            { type: commons.InitCommonsService }
        ]; };
        UserRoleFormComponent.propDecorators = {
            access: [{ type: core.ViewChild, args: [UserRoleAccessComponent, { static: false },] }]
        };
        return UserRoleFormComponent;
    }(gallery.IFormView));
    if (false) {
        /** @type {?} */
        UserRoleFormComponent.prototype.access;
        /** @type {?} */
        UserRoleFormComponent.prototype.data;
        /** @type {?} */
        UserRoleFormComponent.prototype.icon;
        /** @type {?} */
        UserRoleFormComponent.prototype.serviceURL;
        /**
         * @type {?}
         * @private
         */
        UserRoleFormComponent.prototype.dirtyAccessDetail;
        /**
         * @type {?}
         * @protected
         */
        UserRoleFormComponent.prototype.vcRef;
        /**
         * @type {?}
         * @protected
         */
        UserRoleFormComponent.prototype.route;
        /**
         * @type {?}
         * @protected
         */
        UserRoleFormComponent.prototype.router;
        /**
         * @type {?}
         * @protected
         */
        UserRoleFormComponent.prototype.dynaDataService;
        /**
         * @type {?}
         * @protected
         */
        UserRoleFormComponent.prototype.translate;
        /**
         * @type {?}
         * @protected
         */
        UserRoleFormComponent.prototype.notificationService;
        /**
         * @type {?}
         * @protected
         */
        UserRoleFormComponent.prototype.auditDialogService;
        /**
         * @type {?}
         * @protected
         */
        UserRoleFormComponent.prototype.confirmationDialogService;
        /**
         * @type {?}
         * @protected
         */
        UserRoleFormComponent.prototype.navigationService;
        /**
         * @type {?}
         * @protected
         */
        UserRoleFormComponent.prototype.init;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AccessDetailResolver = /** @class */ (function () {
        function AccessDetailResolver(dynService) {
            this.dynService = dynService;
        }
        /**
         * @param {?} route
         * @param {?} state
         * @return {?}
         */
        AccessDetailResolver.prototype.resolve = /**
         * @param {?} route
         * @param {?} state
         * @return {?}
         */
        function (route, state) {
            /** @type {?} */
            var id = route.queryParams['id'];
            if (id === undefined) {
                id = 0;
            }
            return this.dynService.getResultList("./service/security/access-details/" + id);
        };
        AccessDetailResolver.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        AccessDetailResolver.ctorParameters = function () { return [
            { type: gallery.DynaDataService }
        ]; };
        return AccessDetailResolver;
    }());
    if (false) {
        /**
         * @type {?}
         * @protected
         */
        AccessDetailResolver.prototype.dynService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var XdfSettingsModule = /** @class */ (function () {
        function XdfSettingsModule() {
        }
        XdfSettingsModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            SystemSettingsComponent,
                            ViewCredencialsDialogComponent,
                            ChangeSecretDialogComponent,
                            ApplicationFormComponent,
                            ValposFormComponent,
                            UserRoleFormComponent,
                            UserRoleAccessComponent
                        ],
                        imports: [
                            overlay.OverlayModule,
                            forms.FormsModule,
                            common.CommonModule,
                            router.RouterModule,
                            core$1.TranslateModule,
                            forms.ReactiveFormsModule,
                            gallery.XdfGalleryModule,
                            material.MatFormFieldModule,
                            material.MatSelectModule,
                            material.MatOptionModule,
                            material.MatInputModule,
                            material.MatButtonModule,
                            ngxScrollbar.NgScrollbarModule,
                            material.MatCheckboxModule,
                            material.MatButtonModule
                        ],
                        entryComponents: [
                            ViewCredencialsDialogComponent,
                            ChangeSecretDialogComponent
                        ],
                        providers: [
                            ChangeSecretDialogService,
                            ViewCredencialsDialogService,
                            AccessDetailResolver
                        ],
                        exports: [
                            SystemSettingsComponent,
                            ViewCredencialsDialogComponent,
                            ChangeSecretDialogComponent,
                            ApplicationFormComponent,
                            UserRoleFormComponent,
                            UserRoleAccessComponent,
                            ValposFormComponent
                        ]
                    },] }
        ];
        return XdfSettingsModule;
    }());

    exports.AccessDetailResolver = AccessDetailResolver;
    exports.ApplicationFormComponent = ApplicationFormComponent;
    exports.ApplicationService = ApplicationService;
    exports.ChangeSecretDialogService = ChangeSecretDialogService;
    exports.Control = Control;
    exports.Program = Program;
    exports.SettingOptions = SettingOptions;
    exports.SystemSettingsComponent = SystemSettingsComponent;
    exports.UserRoleAccessComponent = UserRoleAccessComponent;
    exports.UserRoleFormComponent = UserRoleFormComponent;
    exports.ValposFormComponent = ValposFormComponent;
    exports.ViewCredencialsDialogService = ViewCredencialsDialogService;
    exports.XdfSettingsModule = XdfSettingsModule;
    exports.basePath = basePath;
    exports.ɵa = ViewCredencialsDialogComponent;
    exports.ɵb = ChangeSecretDialogComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=xdf-settings.umd.js.map
