import { Router, CanActivate, CanLoad } from '@angular/router';
import { AuthenticationService } from '@xdf/commons';
import { Observable } from 'rxjs';
export declare class OAuthGuard implements CanActivate, CanLoad {
    private router;
    private authenticationService;
    canLoad(): boolean | Observable<boolean> | Promise<boolean>;
    constructor(router: Router, authenticationService: AuthenticationService);
    canActivate(): Observable<boolean> | Promise<boolean> | boolean;
}
