import { BehaviorSubject, Observable } from 'rxjs';
import { User } from '../model/User';
export declare abstract class AuthenticationService {
    protected currentUserSubject: BehaviorSubject<User>;
    currentUser: Observable<any>;
    constructor();
    readonly currentUserValue: User;
    abstract login(username: string, password: string): Observable<User>;
    abstract logout(): void;
}
