import { Injector } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
import { AuthenticationService, User } from '@xdf/commons';
export declare class ByteAuthenticationService extends AuthenticationService {
    private http;
    private injector;
    constructor(http: HttpClient, injector: Injector);
    login(username: string, password: string): Observable<User>;
    logout(): Observable<unknown>;
}
