import { OnInit, ChangeDetectorRef } from '@angular/core';
import { DataService } from '../../crud/services/data.service';
import { FormGroupUtils } from '../../../utils/form-group-utils';
import { ValidatorUtils } from '../../../utils/validator-utils';
import { ControlValueAccessor } from '@angular/forms';
import { CdkDragDrop } from '@angular/cdk/drag-drop';
export declare class DragAndDropListComponent implements OnInit, ControlValueAccessor {
    private cdr;
    private formGroupUtils;
    private validatorUtils;
    labelcontrol: any;
    label: string;
    placeholder: string;
    values: [];
    showInline: boolean;
    name: string;
    suggest: string;
    disabled: boolean;
    requiredSelection: boolean;
    options: any;
    formGroup: any;
    service: DataService;
    sourceValue: string;
    sourceLabel: string;
    hasError: boolean;
    todos: Array<any>;
    selected: Array<any>;
    value: any;
    constructor(cdr: ChangeDetectorRef, formGroupUtils: FormGroupUtils, validatorUtils: ValidatorUtils);
    ngOnInit(): void;
    loadArrays(): void;
    onDrop(event: CdkDragDrop<string[]>): void;
    private onChangeCallback;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    writeValue(value: any): void;
    setDisabledState(isDisabled: boolean): void;
    getErrors(): any[];
}
